/*

avrdude -c usbtiny -p t85 -U flash:w:rdm_gate.hex -U lfuse:w:0xe2:m -U hfuse:w:0x5f:m -U efuse:w:0xff:m 

 -U lfuse:w:0xe2:m 
 -U hfuse:w:0x5f:m   /!\ disable reset ---> need fuse doctor for re_flashing   hfuse:w:0xdf:m
 -U efuse:w:0xff:m  
 
 */

boolean buttonStatePLAY = 0;
boolean lastButtonStatePLAY = 0; 
boolean pair;   
const byte RLED = 0;       // random gate out // pin 5
const byte LEDI = 1;       // gate out        // pin 6
const byte LEDP = 2;       // gate out        // pin 7
const byte buttonPLAY = 4;//gate in           // pin 3
short sw;  //switch pot mode 0, 1, 2 (pin 1), prob pot (pin 2)
/*
C -->as clock, 1 -->clock end cut, 2 -->clock /2 end cut, R -->random 

MODE 0 --- ledP 1/1, ledI 1/2, Rled Random 		--> C 2 R
MODE 1 --- ledP Rdm, ledI Rdm, Rled Random 		--> R R R
MODE 2 --- ledP 1/1, ledI 1/1, Rled 1/1			--> C C C
*/
byte state = 2; 
short prob;
short prub;
short probMAX = 40; // steps 
short rdmA = 2; 
short rdmB = 2; 
short rdmC = 2; 
int dly = 1; // ms trigger 

void setup()
{
	pinMode(RLED, OUTPUT);
	pinMode(LEDP, OUTPUT);
	pinMode(LEDI, OUTPUT);
	pinMode(buttonPLAY, INPUT_PULLUP);
}

void loop() 
{
	prob = map (analogRead(A3), 0 , 1023, 3, probMAX); // probability pot // pin 2
	buttonStatePLAY = digitalRead(buttonPLAY);
	sw = map (analogRead(A0), 0 , 1023, 0, 5);  // mode select pot // pin 1
	prub = prob+1;
	
	if (buttonStatePLAY != lastButtonStatePLAY)
	{
		if (sw == 0 || sw == 1)
	    {
		if (buttonStatePLAY == LOW)
			{ 
				if (state < prob+2)
				{
					state+=1;
					pair = state & 1;
					
					if (state != prob+2)
					{
						digitalWrite(LEDP,HIGH);
						delay(dly);
						digitalWrite(LEDP,LOW);
					}
					if (state != prob+2 && pair == 1) 
				    {
					digitalWrite(LEDI,HIGH);
					delay(dly);
					digitalWrite(LEDI,LOW);
				    }	
				} 
				if (state >= prob+2 || state == rdmA) 
				{
					digitalWrite(RLED,HIGH);
					digitalWrite(LEDP,HIGH);
					delay(dly);
					digitalWrite(RLED,LOW);
					digitalWrite(LEDP,LOW);
					rdmA = random (2, prob+2);
					state = 2;
				}				
			}	
		}
		
		if (sw == 2 || sw == 3)
		{
			if (buttonStatePLAY == LOW)
			{ 
				if (state < prub)
				{
					state+=1;
				} 
				if (state >= prub || state == rdmA) 
				{
					digitalWrite(RLED,HIGH);
					delay(dly);
					digitalWrite(RLED,LOW);
					rdmA = random (2, prub);
					rdmB = random (2, prub);
					rdmC = random (2, prub);
					state = 2;
				}	
				if (state >= prub || state == rdmB) 
				{
					digitalWrite(LEDI,HIGH);
					delay(dly);
					digitalWrite(LEDI,LOW);
					rdmA = random (2, prub);
					rdmB = random (2, prub);
					rdmC = random (2, prub);
					state = 2;
				}	
				if (state >= prub || state == rdmC) 
				{
					digitalWrite(LEDP,HIGH);
					delay(dly);
					digitalWrite(LEDP,LOW);
					rdmA = random (2, prub);
					rdmB = random (2, prub);
					rdmC = random (2, prub);
					state = 2;
				}				
			}
		}
		if (sw == 4 || sw == 5)
		{
			if (buttonStatePLAY == LOW)
			{ 
				if (state < prub)
				{
					state+=1;
					
					if (state != prub)
					{
						digitalWrite(LEDP,HIGH);
						digitalWrite(LEDI,HIGH);
						digitalWrite(RLED,HIGH);
						delay(dly);
						digitalWrite(LEDP,LOW);
						digitalWrite(LEDI,LOW);
						digitalWrite(RLED,LOW);
					}
				} 
				if (state >= prob+1) 
				{
					digitalWrite(LEDP,HIGH);
					digitalWrite(LEDI,HIGH);
					digitalWrite(RLED,HIGH);
					delay(dly);
					digitalWrite(LEDP,LOW);
					digitalWrite(LEDI,LOW);
					digitalWrite(RLED,LOW);
					state = 2;
				}			
			}
		}
	}
	lastButtonStatePLAY = buttonStatePLAY;
}
